local MakePlayerCharacter = require "prefabs/player_common"
local assets = {Asset("SCRIPT", "scripts/prefabs/player_common.lua")}
local prefabs = {}
local start_inv = { "goldenaxe", "goldenshovel", "goldenpickaxe", "cutgrass", "cutgrass", "cutgrass", "cutgrass", "twigs", "twigs", "twigs", "twigs" }

local function onbecamehuman(inst)
	inst.components.locomotor:SetExternalSpeedMultiplier(inst, "kaban_speed_mod", 1)
end

local function onbecameghost(inst)
   inst.components.locomotor:RemoveExternalSpeedMultiplier(inst, "kaban_speed_mod")
end

local function onload(inst)
    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
    inst:ListenForEvent("ms_becameghost", onbecameghost)
    if inst:HasTag("playerghost") then
        onbecameghost(inst)
    else
        onbecamehuman(inst)
    end
end

local common_postinit = function(inst) 
	inst.MiniMapEntity:SetIcon( "kaban.tex" )
end

local function WISDOM(inst)
	if inst.components.sanity.current >= (130) and inst.components.sanity.current <= (200) then 
		inst.components.builder.science_bonus = (1)
		inst.components.builder.magic_bonus = (1)
		inst.components.builder.ancient_bonus = (1)
		inst.components.builder.volcanic_bonus = (1)
    elseif inst.components.sanity.current >= (70) and inst.components.sanity.current < (130) then 
		inst.components.builder.science_bonus = (0)
		inst.components.builder.magic_bonus = (0)
		inst.components.builder.ancient_bonus = (0)
		inst.components.builder.volcanic_bonus = (0)
    elseif inst.components.sanity.current > (0) and inst.components.sanity.current < (70)then 
		inst.components.builder.science_bonus = (1)
		inst.components.builder.magic_bonus = (1)
		inst.components.builder.ancient_bonus = (1)
		inst.components.builder.volcanic_bonus = (1)
	end
end
	
local master_postinit = function(inst)
	inst.soundsname = "willow"
	inst.components.health:SetMaxHealth(150)
	inst.components.hunger:SetMax(200)
	inst.components.sanity:SetMax(200)
	inst.components.builder.science_bonus = 1
	inst.components.builder.magic_bonus = 1
	inst.components.builder.ancient_bonus = 1
	inst.components.builder.volcanic_bonus = 1
	
	inst.OnLoad = onload
    inst.OnNewSpawn = onload
	
		inst._GetAttacked = inst.components.combat.GetAttacked
		inst.components.combat.GetAttacked = function(attacker, damage, weapon, stimuli)
			if math.random() > .50 then
				inst._GetAttacked(attacker, damage, weapon, stimuli) 
			else
				inst.components.talker:Say("Please. Don't eat me!")
			end
	end
	return inst
end

return MakePlayerCharacter("kaban", prefabs, assets, common_postinit, master_postinit, start_inv)
